require 'peg'

####### a^(2^n-1) ######
### CFGなら a^(2n-1) ###

as = Pegexp.new <<PEG
  A <- aAa / a
PEG

#puts as
p [as.match("aaaaa"), 3]
p [as.match("aaaaaaa"), 7]

####### MiddleFinderもどき ######
### CFGなら真中にaがある文字列 ##

mf = Pegexp.new <<PEG
  M <- A.
  A <- XAX / a
  X <- a/b
PEG

#puts mf
p [mf.match("aaaaa."), nil]
p [mf.match("bbabb."), 6]
p [mf.match("aaaaaaa."), 8]

####### すうしき #######
######## ふつう ########

arith = Pegexp.new <<PEG
  A <- M + A / M
  M <- P * M / P
  P <- ( A ) / D
  D <- 0/1/2/3/4/5/6/7/8/9
PEG

#puts arith
p [arith.match( "(1+2)*3+4-5" ), 9]

####### a^n b^n c^n #######
### Predicateの除去の例 ###

abc = Pegexp.new <<PEG
  S <- I A Y      # S <- &X a+ Y  (a^n b^n c^n)
    I <- JTZ /    # &を使わないよう変形...
    J <- KTZ /
    K <- XbZ / X
    Z <- TZ  /
    T <- a/b/c
  A <- aA  / a    # a+
  X <- aXb / ab   # a^n b^n
  Y <- bYc / bc   # b^n c^n
PEG

#puts abc
p [abc.match("aabbccc"), 6]
p [abc.match("abbcc"), nil]
p [abc.match("aabb"), nil]

####### abababa.... #######
### てきとうに簡単な例 ####

ab = Pegexp.new <<PEG
  A <- a B / a
  B <- b A / b
PEG

puts ab
p abc.example.take(20)
